import os


# ======================================================================================================================
class FileListFullPathIterator(object):
  # --------------------------------------------------------------------------------------------------------------------
  def __init__(self, filelist):
    self.filelist = filelist
    self.index = 0
  # --------------------------------------------------------------------------------------------------------------------
  def __iter__(self):
    return self
  # --------------------------------------------------------------------------------------------------------------------
  def __next__(self):
    if self.index >= len(self.filelist):
      raise StopIteration
    sFileFullPath = os.path.join(self.filelist.parent_folder_path, self.filelist[self.index])
    self.index += 1
    return sFileFullPath
  # --------------------------------------------------------------------------------------------------------------------
# ======================================================================================================================





# ======================================================================================================================
class FileList(list):
  # --------------------------------------------------------------------------------------------------------------------
  def __init__(self, parent_folder_path=None):
    self.parent_folder_path = parent_folder_path
  # --------------------------------------------------------------------------------------------------------------------
  @property
  def full_paths(self):
    if self.parent_folder_path is not None:
      return FileListFullPathIterator(self)
    else:
      return None
  # --------------------------------------------------------------------------------------------------------------------
# ======================================================================================================================